/******************************************************************************
 * $Id: gfx_texture.hh,v 1.24 2006/11/19 05:47:23 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Texture (generic, gfxsys-neutral).
 *//*
 * LEGAL:	COPYRIGHT (C) 2004 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 ******************************************************************************/

#ifndef GFX_TEXTURE_HH
#define GFX_TEXTURE_HH 1

// -----------------------------------------------------------------------------

// Compile BGRA8 or RGBA8.  BGRA8 is faster on Nvidia hw.
#define COMPILE_TEXEL32_BGRA8 1
//#define COMPILE_TEXEL32_RGBA8 1

// -----------------------------------------------------------------------------

//------------------------------------------------------------------------------
namespace gfx {

/// @brief 2D texture coordinate.
struct TexCoord2
{
	fp	x;
	fp	y;
};

// Generic texture definitions:

enum { DONT_MIPMAP=0, DO_MIPMAP=1 }; // bool

} // namespace gfx
//------------------------------------------------------------------------------

// Include gfxsys-specific Texture class.
#if GFXSYS_OPENGL
#	include "gfx_texture_opengl.hh"
#else
#	error
#endif

//------------------------------------------------------------------------------
namespace gfx {

bool
operator<( Texture2& a, Texture2& b );

bool
operator<( TexCoord2& a, TexCoord2& b );

} // namespace gfx
//------------------------------------------------------------------------------

#endif // GFX_TEXTURE_HH
