/*****************************************************************************
 * $Id: mod_base_listeners.hh,v 1.1 2006/11/24 21:56:57 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Event listeners.
 *//*
 * LEGAL:	COPYRIGHT (C) 2004 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#if COMPILING_MODULE

// Reused for declaring listeners as friends of the Module class.

#undef MODULE_BASE_LISTENERS
#undef MODULE_BASE_LISTENER_TYPE
#if MODULE_BASE_LISTENERS_FRIEND

#	define MODULE_BASE_LISTENERS			1
#	define MODULE_BASE_LISTENER_TYPE		friend
#elif MOD_BASE_LISTENERS_CC
#	define MODULE_BASE_LISTENERS			1
#	define MODULE_BASE_LISTENER_TYPE
#endif

#if MODULE_BASE_LISTENERS

MODULE_BASE_LISTENER_TYPE void
Listener_ModuleBase_EngineReady( void );

MODULE_BASE_LISTENER_TYPE void
Listener_ModuleBase_Exit( void );

MODULE_BASE_LISTENER_TYPE void
Listener_ModuleBase_Animate( void );

MODULE_BASE_LISTENER_TYPE void
Listener_ModuleBase_Tick( void );

MODULE_BASE_LISTENER_TYPE void
Listener_ModuleBase_NeedTextureDirVec( void );

MODULE_BASE_LISTENER_TYPE void
Listener_ModuleBase_PrintStats( void );

#endif // MODULE_BASE_LISTENERS

#endif // COMPILING_MODULE
